/**
 * Cod sursa pentru Line Follower
 * Sursa apartine lui Sin Andrei si Radoveneanu Sorin
 * Grupa 334 CC
 */

#include <avr/io.h>
#include <avr/interrupt.h>
#define F_CPU 16000000
#include <util/delay.h>


#define NR_SEN 8

/* directii */

#define DREAPTA 0x22
#define STANGA 0x84
#define INAINTE 0x56
#define STOP 0x00
#define INAPOI 0x59

#define NEINIT -1;


/* initializare */

void init()
{
	/* senzori */
	PORTA = 0xFF;
	DDRA = 0x00;

	/* input driver */
	PORTC = 0x00;
	DDRC = 0xFF;

	/* driver ENABLE_A si ENABLE_B */
	PORTD = 0x00;
	PORTD = 0xFF;
	DDRD |= (1 <<PD4) | (1<<PD5);

	/* timer */
	TCCR1A = (1 << WGM10) | (1 << COM1A1) | (1 << COM1B1);
	TCCR1B = (1 << WGM12) | (1 << CS11);

}

void move(unsigned char dir,int speed)
{
	PORTC = dir;
	OCR1A = speed;
	OCR1B = speed;
}

int main()
{
	init();

	int i, right, left;

	while(1){

		right = 0;
		left = 0;

		/* right sensors */
		if(!bit_is_set(PINA, 0))
			right++;
		if(!bit_is_set(PINA, 1))
			right++;
		if(!bit_is_set(PINA, 2))
			right++;
		if(!bit_is_set(PINA, 3))
			right++;

		/* left sensors */
		if(!bit_is_set(PINA, 4))
			left++;
		if(!bit_is_set(PINA, 5))
			left++;
		if(!bit_is_set(PINA, 6))
			left++;
		if(!bit_is_set(PINA, 7))
			left++;

		if(left > right)
			move(STANGA,200 + left);

		if(left < right)
			move(DREAPTA,200 + (NR_SEN - right));

		if(left == right)
			move(INAINTE,200);

		_delay_ms(50);
	}

	return 0;

}
